summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorLars Wendler <polynomial-c@gentoo.org>2021-11-25 10:17:20 +0100
committerLars Wendler <polynomial-c@gentoo.org>2021-11-25 10:17:36 +0100
commitb395551781151147112002d3520a4ee4826cdf84 (patch)
treed1834dfeaf784a988ac3e46d2077bdb64064b892
parentdev-lang/ruby: add 2.6.9, 2.7.5, 3.0.3 (diff)
downloadgentoo-b395551781151147112002d3520a4ee4826cdf84.tar.gz
gentoo-b395551781151147112002d3520a4ee4826cdf84.tar.bz2
gentoo-b395551781151147112002d3520a4ee4826cdf84.zip
dev-vcs/git: Bump to version 2.34.1
Signed-off-by: Lars Wendler <polynomial-c@gentoo.org>
-rw-r--r--dev-vcs/git/Manifest3
-rw-r--r--dev-vcs/git/git-2.34.1.ebuild667
2 files changed, 670 insertions, 0 deletions
diff --git a/dev-vcs/git/Manifest b/dev-vcs/git/Manifest
index 74592f0e741..11ca0d38273 100644
--- a/dev-vcs/git/Manifest
+++ b/dev-vcs/git/Manifest
@@ -1,9 +1,12 @@
DIST git-2.32.0.tar.xz 6551348 BLAKE2B 546203ce3f749ba806866a9e9767bc807794cec435fd0b60306ae6cd2b1b17a0159ef9774c79c4f59d0dba45b36941085b55f103e1820450d560bffa41d1058f SHA512 1ab3e7022ccee411d14a7da5c37d6259ef5c0f85ebed8f49698e25c65cbc7a46f8096919fcb6568360bfe284dd7475b596eee1a167db966096255a405853837c
DIST git-2.33.1.tar.xz 6558636 BLAKE2B f4959d5309f85e063448673a3f06f1d3cdd65ced5f5173cfe5a38df3b5547cae1c08275bda02e48307e8290628735e2ea1ff49222262e7cd29b252a6aa4d4a15 SHA512 16d417183232e1057bea754d59cdf4bbacc5f1527d1de6ee04cdd293a2512bfa7208e20f6130816605528b59cb1bc3188c5bddf1a42c1413095ee74e44dd2f91
DIST git-2.34.0.tar.xz 6623924 BLAKE2B 1b50fb2594ad7c87df5214495a0a24f8122f67e844b0312bbee44d9cfdad201fe589a819cf56971706df534001cdbd52d4174fa72124212d4276cee9acd37759 SHA512 3102c1ebe408eb549ebd0f9b1420663ed04a2720e4dc676c1854a9e7b8306bb49dc931b734aa7eb612eb7adc2ad92730c0d2dd704dbd859ba61e5ceba909fcc3
+DIST git-2.34.1.tar.xz 6623760 BLAKE2B 9b5d7a450ec495898bcc0e1f6ae87c0ad102d039cf7c4106cdfe3ada501d9bfaf22b83c522de383d3c01f7d5a29dbfd7fc44b371efa8fc3a418ab3c609a692c1 SHA512 a1a8e9e6f64b1da25508fbd2f783564dcdbe181fb5ff1ebab3bdac6db6094e18acc334479a1abf22ac17ce4f733cc3e10a664db9ab234cd523735a3f027b42db
DIST git-htmldocs-2.32.0.tar.xz 1381664 BLAKE2B d1b47aa99d32a252fd20df26eff44a558044f3a389379b161bb43621eb28375eb0621969849a31938ba7fc9fc58b140d27d703559ea5735d0a0ffd2e93cd9692 SHA512 12b84e342f0d19afe385ab8a685ae625e86c3295d1555992e0c427b361aa2cdfc89a679e7dbc468d3568a325dafbf699468aadcdb02f93e372eff3dd96a7cf7f
DIST git-htmldocs-2.33.1.tar.xz 1396744 BLAKE2B cbd65cf08fc7ea466fcd72820ba3e2135ade37f69c436a4ee7276dc71fb62f6270b71e2f46d981f5681a0fd3c30613d61680c2ef2460d0d7d292f7455e114128 SHA512 5b856b919067e1f644539d43a85aab6f602537ea0970b6248b471e3fa6756a8494f0525a69d22ad3795fcf9e106ff8439e0f6716ba0b8c895d7aad8c59e5bd74
DIST git-htmldocs-2.34.0.tar.xz 1406204 BLAKE2B db606a9015a4efa8d162dbdf3eea34a60f87a85e2acbeed23ff731e241086354bd278726fb301eedc83ff9f44a71e3c68c78b151d4e837b32a188ad5ccca3b3f SHA512 8f6e768ebeb4dd6cc45537391c30f47cfab67fd7abb308d0b15a082a463c0c01cd94f855f9e7ee2e4b2983300d31431666ce84dc9243b0ec37869d5a868862c1
+DIST git-htmldocs-2.34.1.tar.xz 1406464 BLAKE2B 6ee2f58df3c1622d96ac4b1a70d4dc3d0c973635774dd6bb89fea3e502dd82d99d676e2f9cb33c14c429c3d4680cd6020213154099b3f7fe71ad67602ca9bc6c SHA512 cf9fa952d43e477528deece9f22d1bb63fa50b3a831fae20812c6af31c1dbaf193abe2fed48ac9966bcf1787442ceed19f00c00e524a1911f0ea31952a52fc8f
DIST git-manpages-2.32.0.tar.xz 491868 BLAKE2B 7598a864246aed771371924604ee13d3f51b839b10b254bb1159dd47266513f5cd6484aab200a7b4ed427edc76538a98e39a040a17201483965175f5e1c5f484 SHA512 5c9950bd5d6904972cddf4afad534197d843c0dee8198d14ec5a3448873cab37dac88295b2a4df3658749f048bda4800b54fdc850517be7208906c911832c66e
DIST git-manpages-2.33.1.tar.xz 494288 BLAKE2B 1f8bd4f23de31a285d3f4327e562dddafdf9f28e8b36334e54f5e280c81fc8170e8b153ca42baa642d02d8e6fdfcac9a8fdd3cee1e32c29bcd53f689d1a6c463 SHA512 d465a7b491046b7a5da6ad1fc6c62b351c69905932e0672263de5a1d3abe1113660cff9fe30c7be1d1695c6170ceca5a11b3f65e9b2d1545f35cc653e4c6ad62
DIST git-manpages-2.34.0.tar.xz 497252 BLAKE2B a61b32cdfea99373edf227f84f8d5e6c6664f5399ce9b213f23368bd6029efe118e6de3ccb02beefdc5311487709916a245667dfe505e9f594e993641df7dfbe SHA512 367b047ac36213d62129a9bbe11617e10cf58a837f13896580dfa7ba2fe485eb3bc662d5b530ff8896039ba8b73219e98e2562f588b4589d27e8fece887d1589
+DIST git-manpages-2.34.1.tar.xz 497280 BLAKE2B aa3c67cec861eb40eda3e7827d3e380fdfb6f189027fb7e5618258b80ac33918cb3c2ca4d2f8dc5fbee959578766564137e9c4818672f5138304270c486658fe SHA512 8f3b56fa477e5aafec3ef29933234c362a372f59ed95694c4fb82ebb82d2a8ebc0ac17ae36caa9185964eef1700ea8732816e73df4ddd918afc949a8371fa0d8
diff --git a/dev-vcs/git/git-2.34.1.ebuild b/dev-vcs/git/git-2.34.1.ebuild
new file mode 100644
index 00000000000..6fd30df8050
--- /dev/null
+++ b/dev-vcs/git/git-2.34.1.ebuild
@@ -0,0 +1,667 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+GENTOO_DEPEND_ON_PERL=no
+
+# bug #329479: git-remote-testgit is not multiple-version aware
+PYTHON_COMPAT=( python3_{8..10} )
+
+inherit toolchain-funcs elisp-common perl-module bash-completion-r1 plocale python-single-r1 systemd
+
+PLOCALES="bg ca de es fr is it ko pt_PT ru sv vi zh_CN"
+if [[ ${PV} == *9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://git.kernel.org/pub/scm/git/git.git"
+ # Please ensure that all _four_ 9999 ebuilds get updated; they track the 4 upstream branches.
+ # See https://git-scm.com/docs/gitworkflows#_graduation
+ # In order of stability:
+ # 9999-r0: maint
+ # 9999-r1: master
+ # 9999-r2: next
+ # 9999-r3: seen
+ case "${PVR}" in
+ 9999) EGIT_BRANCH=maint ;;
+ 9999-r1) EGIT_BRANCH=master ;;
+ 9999-r2) EGIT_BRANCH=next;;
+ 9999-r3) EGIT_BRANCH=seen ;;
+ esac
+fi
+
+MY_PV="${PV/_rc/.rc}"
+MY_P="${PN}-${MY_PV}"
+
+DOC_VER="${MY_PV}"
+
+DESCRIPTION="stupid content tracker: distributed VCS designed for speed and efficiency"
+HOMEPAGE="https://www.git-scm.com/"
+if [[ ${PV} != *9999 ]]; then
+ SRC_URI_SUFFIX="xz"
+ SRC_URI_KORG="https://www.kernel.org/pub/software/scm/git"
+ [[ "${PV/rc}" != "${PV}" ]] && SRC_URI_KORG+='/testing'
+ SRC_URI="${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
+ ${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
+ doc? (
+ ${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
+ )"
+ [[ "${PV}" == *_rc* ]] || \
+ KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+fi
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="+blksha1 +curl cgi doc emacs gnome-keyring +gpg highlight +iconv mediawiki mediawiki-experimental +nls +pcre perforce +perl +ppcsha1 subversion tk +threads +webdav xinetd cvs test"
+
+# Common to both DEPEND and RDEPEND
+DEPEND="
+ gnome-keyring? (
+ app-crypt/libsecret
+ dev-libs/glib:2
+ )
+ dev-libs/openssl:0=
+ sys-libs/zlib
+ pcre? ( dev-libs/libpcre2:= )
+ perl? ( dev-lang/perl:=[-build(-)] )
+ tk? ( dev-lang/tk:0= )
+ curl? (
+ net-misc/curl
+ webdav? ( dev-libs/expat )
+ )
+ iconv? ( virtual/libiconv )
+"
+
+RDEPEND="${DEPEND}
+ gpg? ( app-crypt/gnupg )
+ perl? (
+ dev-perl/Error
+ dev-perl/MailTools
+ dev-perl/Authen-SASL
+ >=virtual/perl-libnet-3.110.0-r4[ssl]
+ cgi? (
+ dev-perl/CGI
+ highlight? ( app-text/highlight )
+ )
+ cvs? (
+ >=dev-vcs/cvsps-2.1:0
+ dev-perl/DBI
+ dev-perl/DBD-SQLite
+ )
+ mediawiki? (
+ dev-perl/DateTime-Format-ISO8601
+ dev-perl/HTML-Tree
+ dev-perl/MediaWiki-API
+ )
+ subversion? (
+ dev-vcs/subversion[-dso(-),perl]
+ dev-perl/libwww-perl
+ dev-perl/TermReadKey
+ )
+ )
+ perforce? ( ${PYTHON_DEPS} )
+"
+
+# This is how info docs are created with Git:
+# .txt/asciidoc --(asciidoc)---------> .xml/docbook
+# .xml/docbook --(docbook2texi.pl)--> .texi
+# .texi --(makeinfo)---------> .info
+BDEPEND="
+ doc? (
+ app-text/asciidoc
+ app-text/docbook2X
+ app-text/xmlto
+ sys-apps/texinfo
+ )
+ emacs? ( >=app-editors/emacs-23.1:* )
+ gnome-keyring? ( virtual/pkgconfig )
+ nls? ( sys-devel/gettext )
+ test? ( app-crypt/gnupg )
+"
+
+# Live ebuild builds man pages and HTML docs, additionally
+if [[ ${PV} == *9999 ]]; then
+ BDEPEND="${BDEPEND}
+ app-text/asciidoc"
+fi
+
+SITEFILE="50${PN}-gentoo.el"
+S="${WORKDIR}/${MY_P}"
+
+REQUIRED_USE="
+ cgi? ( perl )
+ cvs? ( perl )
+ mediawiki? ( perl )
+ mediawiki-experimental? ( mediawiki )
+ perforce? ( ${PYTHON_REQUIRED_USE} )
+ subversion? ( perl )
+ webdav? ( curl )
+"
+
+RESTRICT="!test? ( test )"
+
+PATCHES=(
+ # bug #350330 - automagic CVS when we don't want it is bad.
+ "${FILESDIR}"/git-2.33.0_rc0-optional-cvs.patch
+
+ # Make submodule output quiet
+ "${FILESDIR}"/git-2.21.0-quiet-submodules-testcase.patch
+)
+
+pkg_setup() {
+ if use subversion && has_version "dev-vcs/subversion[dso]" ; then
+ ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
+ ewarn "with USE=dso, there may be weird crashes in git-svn. You"
+ ewarn "have been warned."
+ fi
+
+ if use perforce ; then
+ python-single-r1_pkg_setup
+ fi
+}
+
+# This is needed because for some obscure reasons future calls to make don't
+# pick up these exports if we export them in src_unpack()
+exportmakeopts() {
+ local extlibs myopts
+
+ myopts=(
+ ASCIIDOC_NO_ROFF=YesPlease
+ $(usex cvs '' NO_CVS=YesPlease)
+ $(usex elibc_musl NO_REGEX=YesPlease '')
+ $(usex iconv '' NO_ICONV=YesPlease)
+ $(usex nls '' NO_GETTEXT=YesPlease)
+ $(usex perl 'INSTALLDIRS=vendor NO_PERL_CPAN_FALLBACKS=YesPlease' NO_PERL=YesPlease)
+ $(usex perforce '' NO_PYTHON=YesPlease)
+ $(usex subversion '' NO_SVN_TESTS=YesPlease)
+ $(usex threads '' NO_PTHREADS=YesPlease)
+ $(usex tk '' NO_TCLTK=YesPlease)
+ )
+
+ if use blksha1 ; then
+ myopts+=( BLK_SHA1=YesPlease )
+ elif use ppcsha1 ; then
+ myopts+=( PPC_SHA1=YesPlease )
+ fi
+
+ if use curl ; then
+ use webdav || myopts+=( NO_EXPAT=YesPlease )
+ else
+ myopts+=( NO_CURL=YesPlease )
+ fi
+
+ # broken assumptions, because of static build system ...
+ myopts+=(
+ NO_FINK=YesPlease
+ NO_DARWIN_PORTS=YesPlease
+ INSTALL=install
+ TAR=tar
+ SHELL_PATH="${EPREFIX}/bin/sh"
+ SANE_TOOL_PATH=
+ OLD_ICONV=
+ NO_EXTERNAL_GREP=
+ )
+
+ # can't define this to null, since the entire makefile depends on it
+ sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile || die
+
+ if use pcre; then
+ myopts+=( USE_LIBPCRE2=YesPlease )
+ extlibs+=( -lpcre2-8 )
+ fi
+ if [[ ${CHOST} == *-solaris* ]]; then
+ myopts+=(
+ NEEDS_LIBICONV=YesPlease
+ HAVE_CLOCK_MONOTONIC=1
+ )
+ if grep -Fq getdelim "${EROOT}"/usr/include/stdio.h ; then
+ myopts+=( HAVE_GETDELIM=1 )
+ fi
+ fi
+
+ if has_version '>=app-text/asciidoc-8.0' ; then
+ myopts+=( ASCIIDOC8=YesPlease )
+ fi
+
+ # Bug 290465:
+ # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
+ if [[ "${CHOST}" == *-uclibc* ]] ; then
+ myopts+=( NO_NSEC=YesPlease )
+ use iconv && myopts+=( NEEDS_LIBICONV=YesPlease )
+ fi
+
+ export MY_MAKEOPTS="${myopts[@]}"
+ export EXTLIBS="${extlibs[@]}"
+}
+
+src_unpack() {
+ if [[ ${PV} != *9999 ]] ; then
+ unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
+ cd "${S}" || die
+ unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
+ if use doc ; then
+ pushd "${S}"/Documentation &>/dev/null || die
+ unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
+ popd &>/dev/null || die
+ fi
+ else
+ git-r3_src_unpack
+ #cp "${FILESDIR}"/GIT-VERSION-GEN .
+ fi
+
+}
+
+src_prepare() {
+ # add experimental patches to improve mediawiki support
+ # see patches for origin
+ if use mediawiki-experimental ; then
+ PATCHES+=(
+ "${FILESDIR}"/git-2.7.0-mediawiki-namespaces.patch
+ "${FILESDIR}"/git-2.7.0-mediawiki-subpages.patch
+ "${FILESDIR}"/git-2.7.0-mediawiki-500pages.patch
+ )
+ fi
+
+ default
+
+ if use prefix ; then
+ # bug #757309
+ eapply "${FILESDIR}"/git-2.31.0-darwin-prefix-gettext.patch
+ fi
+
+ sed -i \
+ -e 's:^\(CFLAGS[[:space:]]*=\).*$:\1 $(OPTCFLAGS) -Wall:' \
+ -e 's:^\(LDFLAGS[[:space:]]*=\).*$:\1 $(OPTLDFLAGS):' \
+ -e 's:^\(CC[[:space:]]* =\).*$:\1$(OPTCC):' \
+ -e 's:^\(AR[[:space:]]* =\).*$:\1$(OPTAR):' \
+ -e "s:\(PYTHON_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
+ -e "s:\(PERL_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
+ Makefile || die
+
+ # Fix docbook2texi command
+ sed -r -i 's/DOCBOOK2X_TEXI[[:space:]]*=[[:space:]]*docbook2x-texi/DOCBOOK2X_TEXI = docbook2texi.pl/' \
+ Documentation/Makefile || die
+}
+
+git_emake() {
+ # bug #320647: PYTHON_PATH
+ local PYTHON_PATH=""
+ use perforce && PYTHON_PATH="${PYTHON}"
+ emake ${MY_MAKEOPTS} \
+ prefix="${EPREFIX}"/usr \
+ htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
+ perllibdir="$(use perl && perl_get_raw_vendorlib)" \
+ sysconfdir="${EPREFIX}"/etc \
+ GIT_TEST_OPTS="--no-color" \
+ OPTAR="$(tc-getAR)" \
+ OPTCC="$(tc-getCC)" \
+ OPTCFLAGS="${CFLAGS}" \
+ OPTLDFLAGS="${LDFLAGS}" \
+ PERL_PATH="${EPREFIX}/usr/bin/perl" \
+ PERL_MM_OPT="" \
+ PYTHON_PATH="${PYTHON_PATH}" \
+ V=1 \
+ "$@"
+}
+
+src_configure() {
+ exportmakeopts
+}
+
+src_compile() {
+ git_emake || die "emake failed"
+
+ if use emacs ; then
+ elisp-compile contrib/emacs/git{,-blame}.el
+ fi
+
+ if use perl && use cgi ; then
+ git_emake gitweb || die "emake gitweb (cgi) failed"
+ fi
+
+ if [[ ${CHOST} == *-darwin* && ! tc-is-gcc ]]; then
+ pushd contrib/credential/osxkeychain &>/dev/null || die
+ git_emake CC=$(tc-getCC) CFLAGS="${CFLAGS}" \
+ || die "emake credential-osxkeychain"
+ popd &>/dev/null || die
+ fi
+
+ pushd Documentation &>/dev/null || die
+ if [[ ${PV} == *9999 ]] ; then
+ git_emake man || die "emake man failed"
+ if use doc ; then
+ git_emake info html || die "emake info html failed"
+ fi
+ else
+ if use doc ; then
+ git_emake info || die "emake info html failed"
+ fi
+ fi
+ popd &>/dev/null || die
+
+ if use gnome-keyring ; then
+ pushd contrib/credential/libsecret &>/dev/null || die
+ git_emake CC="$(tc-getCC)" CFLAGS="${CFLAGS}" PKG_CONFIG="$(tc-getPKG_CONFIG)"
+ popd &>/dev/null || die
+ fi
+
+ pushd contrib/subtree &>/dev/null || die
+ git_emake git-subtree || die
+ # git-subtree.1 requires the full USE=doc dependency stack
+ use doc && git_emake git-subtree.html git-subtree.1
+ popd &>/dev/null || die
+
+ pushd contrib/diff-highlight &>/dev/null || die
+ git_emake || die
+ popd &>/dev/null || die
+
+ if use mediawiki ; then
+ pushd contrib/mw-to-git &>/dev/null || die
+ git_emake || die
+ popd &>/dev/null || die
+
+ fi
+}
+
+src_install() {
+ git_emake DESTDIR="${D}" install || die "make install failed"
+
+ if [[ ${CHOST} == *-darwin* && ! tc-is-gcc ]]; then
+ dobin contrib/credential/osxkeychain/git-credential-osxkeychain
+ fi
+
+ # Depending on the tarball and manual rebuild of the documentation, the
+ # manpages may exist in either OR both of these directories.
+ find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
+ find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
+ dodoc README* Documentation/{SubmittingPatches,CodingGuidelines}
+ use doc && dodir /usr/share/doc/${PF}/html
+ local d
+ for d in / /howto/ /technical/ ; do
+ docinto ${d}
+ dodoc Documentation${d}*.txt
+ if use doc ; then
+ docinto ${d}/html
+ dodoc Documentation${d}*.html
+ fi
+ done
+ docinto /
+ # Upstream does not ship this pre-built :-(
+ use doc && doinfo Documentation/{git,gitman}.info
+
+ newbashcomp contrib/completion/git-completion.bash ${PN}
+ bashcomp_alias git gitk
+ # Not really a bash-completion file (bug #477920)
+ # but still needed uncompressed (bug #507480)
+ insinto /usr/share/${PN}
+ doins contrib/completion/git-prompt.sh
+
+ if use emacs ; then
+ elisp-install ${PN} contrib/emacs/git.{el,elc}
+ elisp-install ${PN} contrib/emacs/git-blame.{el,elc}
+ #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc}
+ # don't add automatically to the load-path, so the sitefile
+ # can do a conditional loading
+ touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
+ elisp-site-file-install "${FILESDIR}"/${SITEFILE}
+ fi
+
+ #dobin contrib/fast-import/git-p4 # Moved upstream
+ #dodoc contrib/fast-import/git-p4.txt # Moved upstream
+ newbin contrib/fast-import/import-tars.perl import-tars
+ exeinto /usr/libexec/git-core/
+ newexe contrib/git-resurrect.sh git-resurrect
+
+ # git-subtree
+ pushd contrib/subtree &>/dev/null || die
+ git_emake DESTDIR="${D}" install || die "Failed to emake install for git-subtree"
+ if use doc ; then
+ # Do not move git subtree install-man outside USE=doc!
+ git_emake DESTDIR="${D}" install-man install-html || die "Failed to emake install-html install-man for git-subtree"
+ fi
+ newdoc README README.git-subtree
+ dodoc git-subtree.txt
+ popd &>/dev/null || die
+
+ if use mediawiki ; then
+ pushd contrib/mw-to-git &>/dev/null || die
+ git_emake DESTDIR="${D}" install
+ popd &>/dev/null || die
+ fi
+
+ # diff-highlight
+ dobin contrib/diff-highlight/diff-highlight
+ newdoc contrib/diff-highlight/README README.diff-highlight
+
+ # git-jump
+ exeinto /usr/libexec/git-core/
+ doexe contrib/git-jump/git-jump
+ newdoc contrib/git-jump/README git-jump.txt
+
+ # git-contacts
+ exeinto /usr/libexec/git-core/
+ doexe contrib/contacts/git-contacts
+ dodoc contrib/contacts/git-contacts.txt
+
+ if use gnome-keyring ; then
+ pushd contrib/credential/libsecret &>/dev/null || die
+ dobin git-credential-libsecret
+ popd &>/dev/null || die
+ fi
+
+ dodir /usr/share/${PN}/contrib
+ # The following are excluded:
+ # completion - installed above
+ # diff-highlight - done above
+ # emacs - installed above
+ # examples - these are stuff that is not used in Git anymore actually
+ # git-jump - done above
+ # gitview - installed above
+ # p4import - excluded because fast-import has a better one
+ # patches - stuff the Git guys made to go upstream to other places
+ # persistent-https - TODO
+ # mw-to-git - TODO
+ # subtree - build seperately
+ # svnimport - use git-svn
+ # thunderbird-patch-inline - fixes thunderbird
+ local contrib_objects=(
+ buildsystems
+ fast-import
+ hg-to-git
+ hooks
+ remotes2config.sh
+ rerere-train.sh
+ stats
+ workdir
+ )
+ local i
+ for i in "${contrib_objects[@]}" ; do
+ cp -rf \
+ "${S}"/contrib/${i} \
+ "${ED}"/usr/share/${PN}/contrib \
+ || die "Failed contrib ${i}"
+ done
+
+ if use perl && use cgi ; then
+ # We used to install in /usr/share/${PN}/gitweb
+ # but upstream installs in /usr/share/gitweb
+ # so we will install a symlink and use their location for compat with other
+ # distros
+ dosym ../gitweb /usr/share/${PN}/gitweb
+
+ # INSTALL discusses configuration issues, not just installation
+ docinto /
+ newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
+ newdoc "${S}"/gitweb/README README.gitweb
+
+ for d in "${ED}"/usr/lib{,64}/perl5/ ; do
+ if [[ -d "${d}" ]] ; then
+ find "${d}" -name .packlist -delete || die
+ fi
+ done
+ else
+ rm -rf "${ED}"/usr/share/gitweb
+ fi
+
+ if ! use subversion ; then
+ rm -f "${ED}"/usr/libexec/git-core/git-svn \
+ "${ED}"/usr/share/man/man1/git-svn.1*
+ fi
+
+ if use xinetd ; then
+ insinto /etc/xinetd.d
+ newins "${FILESDIR}"/git-daemon.xinetd git-daemon
+ fi
+
+ if ! use prefix ; then
+ newinitd "${FILESDIR}"/git-daemon-r1.initd git-daemon
+ newconfd "${FILESDIR}"/git-daemon.confd git-daemon
+ systemd_newunit "${FILESDIR}/git-daemon_at-r1.service" \
+ "git-daemon@.service"
+ systemd_dounit "${FILESDIR}/git-daemon.socket"
+ fi
+
+ perl_delete_localpod
+
+ # Remove disabled linguas
+ # we could remove sources in src_prepare, but install does not
+ # handle missing locale dir well
+ rm_loc() {
+ if [[ -e "${ED}/usr/share/locale/${1}" ]] ; then
+ rm -r "${ED}/usr/share/locale/${1}" || die
+ fi
+ }
+ plocale_for_each_disabled_locale rm_loc
+}
+
+src_test() {
+ local disabled=()
+ local tests_cvs=(
+ t9200-git-cvsexportcommit.sh
+ t9400-git-cvsserver-server.sh
+ t9401-git-cvsserver-crlf.sh
+ t9402-git-cvsserver-refs.sh
+ t9600-cvsimport.sh
+ t9601-cvsimport-vendor-branch.sh
+ t9602-cvsimport-branches-tags.sh
+ t9603-cvsimport-patchsets.sh
+ t9604-cvsimport-timestamps.sh
+ )
+ local tests_perl=(
+ t3701-add-interactive.sh
+ t5502-quickfetch.sh
+ t5512-ls-remote.sh
+ t5520-pull.sh
+ t7106-reset-unborn-branch.sh
+ t7501-commit.sh
+ )
+ # Bug #225601 - t0004 is not suitable for root perm
+ # Bug #219839 - t1004 is not suitable for root perm
+ # t0001-init.sh - check for init notices EPERM* fails
+ local tests_nonroot=(
+ t0001-init.sh
+ t0004-unwritable.sh
+ t0070-fundamental.sh
+ t1004-read-tree-m-u-wf.sh
+ t3700-add.sh
+ t7300-clean.sh
+ )
+ # t9100 still fails with symlinks in SVN 1.7
+ local test_svn=( t9100-git-svn-basic.sh )
+
+ # Unzip is used only for the testcase code, not by any normal parts of Git.
+ if ! has_version app-arch/unzip ; then
+ einfo "Disabling tar-tree tests"
+ disabled+=( t5000-tar-tree.sh )
+ fi
+
+ local cvs=0
+ use cvs && let cvs=${cvs}+1
+ if [[ ${EUID} -eq 0 ]] ; then
+ if [[ ${cvs} -eq 1 ]] ; then
+ ewarn "Skipping CVS tests because CVS does not work as root!"
+ ewarn "You should retest with FEATURES=userpriv!"
+ disabled+=( ${tests_cvs[@]} )
+ fi
+ einfo "Skipping other tests that require being non-root"
+ disabled+=( ${tests_nonroot[@]} )
+ else
+ [[ ${cvs} -gt 0 ]] && \
+ has_version dev-vcs/cvs && \
+ let cvs=${cvs}+1
+ [[ ${cvs} -gt 1 ]] && \
+ has_version "dev-vcs/cvs[server]" && \
+ let cvs=${cvs}+1
+ if [[ ${cvs} -lt 3 ]] ; then
+ einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
+ disabled+=( ${tests_cvs[@]} )
+ fi
+ fi
+
+ if ! use perl ; then
+ einfo "Disabling tests that need Perl"
+ disabled+=( ${tests_perl[@]} )
+ fi
+
+ einfo "Disabling tests that fail with SVN 1.7"
+ disabled+=( ${test_svn[@]} )
+
+ # Reset all previously disabled tests
+ pushd t &>/dev/null || die
+ local i
+ for i in *.sh.DISABLED ; do
+ [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
+ done
+ einfo "Disabled tests:"
+ for i in ${disabled[@]} ; do
+ if [[ -f "${i}" ]] ; then
+ mv -f "${i}" "${i}.DISABLED" && einfo "Disabled ${i}"
+ fi
+ done
+
+ # Avoid the test system removing the results because we want them ourselves
+ sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' -i Makefile || die
+
+ # Clean old results first, must always run
+ nonfatal git_emake clean
+ popd &>/dev/null || die
+
+ # Now run the tests, keep going if we hit an error, and don't terminate on
+ # failure
+ local rc
+ einfo "Start test run"
+ #MAKEOPTS=-j1
+ nonfatal git_emake --keep-going test
+ rc=$?
+
+ # Display nice results, now print the results
+ pushd t &>/dev/null || die
+ nonfatal git_emake aggregate-results
+
+ # And bail if there was a problem
+ [[ ${rc} -eq 0 ]] || die "tests failed. Please file a bug."
+}
+
+showpkgdeps() {
+ local pkg=$1
+ shift
+ elog " $(printf "%-17s:" ${pkg}) ${@}"
+}
+
+pkg_postinst() {
+ use emacs && elisp-site-regen
+ elog "Please read /usr/share/bash-completion/completions/git for Git bash command"
+ elog "completion."
+ elog "Please read /usr/share/git/git-prompt.sh for Git bash prompt"
+ elog "Note that the prompt bash code is now in that separate script"
+ elog "These additional scripts need some dependencies:"
+ echo
+ showpkgdeps git-quiltimport "dev-util/quilt"
+ showpkgdeps git-instaweb \
+ "|| ( www-servers/lighttpd www-servers/apache www-servers/nginx )"
+ echo
+ use mediawiki-experimental && ewarn "Using experimental git-mediawiki patches. The stability of cloned wiki filesystems is not guaranteed."
+}
+
+pkg_postrm() {
+ use emacs && elisp-site-regen
+}